functor PPrint(ImpAst : IMPAST) : PPRINT = struct
  
  structure ImpAst = ImpAst

  fun pprintLoc l = print l

  local 
    open ImpAst
  in
    fun pprintAexp (N n) = print(Int.toString n)
      | pprintAexp (Loc l) = pprintLoc l
      | pprintAexp (Plus(a1, a2)) = (print "("; pprintAexp(a1); print " + "; pprintAexp(a2); print ")")
      | pprintAexp (Minus(a1, a2)) = (print "("; pprintAexp(a1); print " - "; pprintAexp(a2); print ")")
      | pprintAexp (Times(a1, a2)) = (print "("; pprintAexp(a1); print " * "; pprintAexp(a2); print ")")
	
    fun pprintBexp (True) = print "true"
      | pprintBexp (False) = print "false"
      | pprintBexp (Equals(a1, a2)) = (print "("; pprintAexp(a1); print " = "; pprintAexp(a2); print ")")
      | pprintBexp (LessEq(a1, a2)) = (print "("; pprintAexp(a1); print " <= "; pprintAexp(a2); print ")")
      | pprintBexp (Not(b)) = (print "not "; pprintBexp(b))
      | pprintBexp (And(b1, b2)) = (print "("; pprintBexp(b1); print " and "; pprintBexp(b2); print ")")
      | pprintBexp (Or(b1, b2)) = (print "("; pprintBexp(b1); print " or "; pprintBexp(b2); print ")")
	
    fun NSpace 0 = ()
      | NSpace n = (print " "; NSpace(n-1))
	
    fun pprintCom' (n, Skip) = (NSpace n; print "skip")
      | pprintCom' (n, Break) = (NSpace n; print "break")
      | pprintCom' (n, Assign(l, a)) = (NSpace n; pprintLoc l; print " := "; pprintAexp a)
      | pprintCom' (n, Seq(c1, c2)) = (pprintCom'(n, c1); print ";\n"; pprintCom'(n, c2))
      | pprintCom' (n, Cond(b, c1, c2)) = (NSpace n; print "if "; pprintBexp b; print " then {\n";
					   pprintCom'(n+2, c1); print "\n"; NSpace n; print "} else {\n";
					   pprintCom'(n+2, c2); print "\n"; NSpace n; print "}")
      | pprintCom' (n, While(b, c)) = (NSpace n; print "while "; pprintBexp b; print " {\n";
				       pprintCom'(n+2, c); print "\n"; NSpace n; print "}")

    fun pprintCom c = pprintCom'(0, c)
  end

end


